/* eslint-disable */
<template>
  <div id="vote-popup">
    <div class="content_lightbox center">
      <p class="txt_20 mb20">
        <strong>Đánh giá của bạn về sản phẩm</strong>
      </p>
      <ul class="list-star">
        <li
          v-for="star in 5"
          :key="star"
          :class="star <= stars ? 'active' : ''"
          @click.prevent="stars = star"
        >
          <svg-icon
            v-if="star <= stars"
            name="star-full"
            class="inline-block align-middle"
          ></svg-icon>
          <svg-icon
            v-else
            name="star-none"
            class="inline-block align-middle"
          ></svg-icon>
        </li>
      </ul>
      <div class="form-default">
        <div class="form-group mb24">
          <label class="block">
            <strong>Bình luận của bạn</strong>
          </label>
          <div class="input-wrap">
            <textarea
              ref="contentRate"
              v-model="content"
              class="form-control textarea"
              placeholder="Mời bạn để lại bình luận"
              @focus="focusInput"
            ></textarea>
            <span v-show="isError" class="error">
              <ul>
                <li v-for="item_error in errors" :key="item_error">
                  {{ item_error }}
                </li>
              </ul>
            </span>
          </div>
        </div>
      </div>
      <div class="button-bottom flex">
        <a
          class="btn btn-default color-white"
          href="javascript:;"
          @click.prevent="rateIt"
        >
          Gửi đánh giá
        </a>
      </div>
    </div>
  </div>
</template>
<script>
import { EventBus } from '~/plugins/bus'
export default {
  // eslint-disable-next-line vue/require-prop-types
  props: ['productSharedUrl', 'addRate'],
  data() {
    return {
      stars: 0,
      content: '',
      isError: false,
      errors: [],
    }
  },
  methods: {
    async rateIt() {
      if (this.stars === 0) {
        this.isError = true
        this.errors[0] = 'Hãy lựa chọn số sao đánh giá'
      } else {
        this.errors[0] = ''
      }
      if (this.content === '') {
        this.isError = true
        this.errors[1] = 'Vui lòng nhập nội dung đánh giá'
      } else {
        this.errors[1] = ''
      }
      if (this.isError === false) {
        const rate = {
          product_shared_url: this.productSharedUrl,
          content: this.content,
          stars: this.stars,
        }
        try {
          await this.$axios.$post('/product/rate/add', rate)
          EventBus.$emit('open-modal', false)
          this.addRate(rate.content, rate.stars)
        } catch (e) {}
      }
    },
    closeModal() {
      EventBus.$emit('open-modal', false)
    },
    focusInput() {
      this.errors[1] = ''
      this.isError = false
      const elContent = this.$refs.contentRate
      elContent.style.height = '5em'
    },
  },
}
</script>
